function Exp01100_parametrosDeExpedicao_Repositories(restEngine){

    
    this.deleteLogExpedicao = function(filial) {
        return restEngine.post('ped_expedicao#/deleteLogExpedicao', {
            "requestType": "Row",
            "row": filial
        });
    };
    
    this.insertLogExpedicao = function(objLog) {
        return restEngine.post('ped#/crud/autgrupop/save', {
            "requestType": "Row",
            "row": objLog
        });
    };
    
    this.getMaxNrautgrupop = function(cdgrupoper, idautgrupop, nrorg) {
        var filter = [
            {
                "name": "CDGRUPOPER",
                "operator": "=",
                "value": cdgrupoper
            },
            {
                "name": "IDAUTGRUPOP",
                "operator": "=",
                "value": idautgrupop
            },{
                "name": "NRORG",
                "operator": "=",
                "value": nrorg
            }
        ];
        return restEngine.post('ped#/crud/autgrupop', {
            "requestType": "FilterData",
            "filter": filter
        });
    };
    
}

Configuration(function(ContextRegister){
    ContextRegister.register('Exp01100_parametrosDeExpedicao_Repositories', Exp01100_parametrosDeExpedicao_Repositories);
});