function Ped08000_tabela_desconto_Controller(templateManager, ScreenService, General, Ped08000_tabela_desconto_Services, restEngine) {
    var checkedFields = [];
    var checkedFieldsReajuste = [];

    this.novoDesconto = function(args){
        Ped08000_tabela_desconto_Services.getNewNRTABDESC().then(function(success){
            args.owner.widget.newRow();
            args.owner.widget.getField('NRTABDESC').setValue(success.dataset.data[0].NRTABDESC);
            args.owner.widget.currentRow.NRTABDESC = success.dataset.data[0].NRTABDESC;
            args.owner.widget.getField('VRPERDESC').readOnly = false;
            // this.changePercDesconto();
        });
        
    };
    
    this.novoItemDescQtde = function(args){
        var nrtabdesc = templateManager.container.getWidget('tabelaDesconto').currentRow.NRTABDESC;
        var cdproduto = templateManager.container.getWidget('descontoProporcional').currentRow.CDPRODUTO;
        var filter = [
            {
                'NRTABDESC': nrtabdesc,
                'CDPRODUTO': cdproduto
            }
        ];
        General.callRestEngine("ped_pedidos#/getNewNRITTABDESC", "DataSet", filter).then(function(success){
            args.owner.widget.newRow();
            args.owner.widget.getField('NRTABDESC').setValue(nrtabdesc);
            args.owner.widget.currentRow.NRTABDESC = nrtabdesc;
            args.owner.widget.getField('CDPRODUTO').setValue(cdproduto);
            args.owner.widget.currentRow.CDPRODUTO = cdproduto;
            args.owner.widget.getField('NRITTABDESC').setValue(success.dataset.data[0].NRITTABDESC);
            args.owner.widget.currentRow.NRITTABDESC = success.dataset.data[0].NRITTABDESC;
        }).catch(function(error){
            ScreenService.showMessage(error.data.error);
        });
    };

    this.saveTabelaDesconto = function(args){
        General.saveCrud(args.owner.widget);//.then(function(success){
            // General.changeWidgetAcessibility(args.owner.widget.widgets,true);
        // });
    };
    this.changePercDesconto = function(){
        var widget = templateManager.container.getWidget('tabelaDesconto');
        var idtipodesc = widget.getField('IDTIPODESC');
        var vrperdesc = widget.getField('VRPERDESC');
        
        if(idtipodesc.value() == '1'){
            vrperdesc.readOnly = false;
        }else{
            vrperdesc.readOnly = true;
            vrperdesc.setValue(0);
        }
    };
    
    this.changeWidgetAcessibility = function(args){
        var widget = templateManager.container.getActiveWidget();
        if(widget.name == 'tabelaDesconto'){
            if (widget.currentRow.IDTIPODESC == 1){
                // General.changeWidgetAcessibility(widget.widgets, false);
                General.changeWidgetAcessibility([widget.widgets[0]], false);
                General.changeWidgetAcessibility([widget.widgets[1]], false);
            } else if (widget.currentRow.IDTIPODESC == 2){
                General.changeWidgetAcessibility([widget.widgets[0]], true);
                General.changeWidgetAcessibility([widget.widgets[1]], false);
            } else if (widget.currentRow.IDTIPODESC == 3){
                General.changeWidgetAcessibility([widget.widgets[0]], false);
                General.changeWidgetAcessibility([widget.widgets[1]], true);
            }
        }
    };
    
    this.prodDescQtde = function(field){
        var widget = field.widget.container.getWidget('listaItemDescQtde');
        widget.dataSourceFilter = [
            {
                name: "P_NRTABDESC",
                operator: "=",
                value: widget.parent.parent.parent.currentRow.NRTABDESC
            },
            {
                name: "P_CDARVPROD",
                operator: "=",
                value: widget.parent.getField('CDARVPROD').value()
            },
            {
                name: "P_TCDARVPROD",
                operator: "=",
                value: ""
            }
        ];
        
        this.showActionNew(field);
    };
    
    this.savelistaItemDescQuantidade = function(widget){
        if (widget.isValid()) {
            if (parseFloat(widget.currentRow.QTFINDESC) > parseFloat(widget.currentRow.QTINIDESC)) {
                this.validaIntervalo(widget);
            } else {
                ScreenService.showMessage('Quantidade final deve er maior que a quntidade inicial.');
            }
        }
    };
    
    this.validaIntervalo = function(widget) {
        var qtini = widget.currentRow.QTINIDESC;
        var qtfin = widget.currentRow.QTFINDESC;
        
        var filtroIni = [
            {
                "name": "P_NRTABDESC",
                "operator": "=",
                "value": widget.currentRow.NRTABDESC
            },
            {
                "name": "CDPRODUTO",
                "operator": "=",
                "value": widget.currentRow.CDPRODUTO
            },
            {
                "name": "P_CDARVPROD",
                "operator": "=",
                "value": widget.getParent().currentRow.CDARVPROD
            },
            {
                "name": "QTINIDESC",
                "operator": "BETWEEN",
                "value": [qtini, qtfin]
            }
        ];
        General.callRestEngine('ped_pedidos#/crud/itemtabdesc_quantidade', 'FilterData', filtroIni).then(function(success){
            if (success.dataset.itemtabdesc_quantidade.length <= 0) {
                var filtroFin = [
                    {
                        "name": "P_NRTABDESC",
                        "operator": "=",
                        "value": widget.currentRow.NRTABDESC
                    },
                    {
                        "name": "CDPRODUTO",
                        "operator": "=",
                        "value": widget.currentRow.CDPRODUTO
                    },
                    {
                        "name": "P_CDARVPROD",
                        "operator": "=",
                        "value": widget.getParent().currentRow.CDARVPROD
                    },
                    {
                        "name": "QTFINDESC",
                        "operator": "BETWEEN",
                        "value": [qtini, qtfin]
                    }
                ]; 
                General.callRestEngine('ped_pedidos#/crud/itemtabdesc_quantidade', 'FilterData', filtroFin).then(function(success){
                    if (success.dataset.itemtabdesc_quantidade.length <= 0) {
                        General.saveCrud(widget);
                    } else {
                        ScreenService.showMessage('Intervalos de quantidade não podem ser sobrepostos.');
                    }
                });
            } else {
                ScreenService.showMessage('Intervalos de quantidade não podem ser sobrepostos.');
            }
        });
    };
    
    this.showActionNew = function(field){
        var widgetLista = templateManager.container.getWidget('listaItemDescQtde');
        if(field.value().length){
            widgetLista.getAction('add').isVisible = true;
            widgetLista.reload();
        } else {
            widgetLista.getAction('add').isVisible = false;
            widgetLista.reload();
        }
    };
    
    this.prodIni = function(widget){
        var row = widget.currentRow;
        widget.getField('NMPRODFIN').readOnly = !row.NMPRODINI;
        widget.getField('NMPRODFIN').readOnlyOnEdit = !row.NMPRODINI;
        if(widget.getField('NMPRODFIN').readOnly == true){ 
            widget.currentRow.NMPRODFIN = "";
        }
        // widget.reload();
        this.prodFin(widget);
    };
    
    this.prodFin = function(widget){
        var row = widget.currentRow;
        widget = widget.container.getWidget('listaItemDescProd');
        widget.dataSourceFilter = [
            {
                name: "P_NRTABDESC",
                operator: "=",
                value: widget.getParent().getParent().currentRow.NRTABDESC
            },
            {
                name: "P_CDNIVELPROD",
                operator: "=",
                value: '5'
            }
        ];
        if(row.NMPRODFIN){
            if(row.P_PRODINI > row.P_PRODFIN){
                ScreenService.showMessage("O codigo do produto inicial não pode ser maior que do final");
                return 0;
            } else { 
                widget.dataSourceFilter.push(
                    {
                        name: "P_PRODINI",
                        operator: "=",
                        value: row.P_PRODINI
                    }
                );
                widget.dataSourceFilter.push(
                    {
                        name: "P_PRODFIN",
                        operator: "=",
                        value: row.P_PRODFIN
                    }
                );
                widget.reload();
            }
        } else {
            widget.dataSourceFilter.push(
                {
                    name: "P_PRODINI",
                    operator: "=",
                    value: "invalido"
                }
            );
        }
    };
    
    this.setView = function(){
        var widget = templateManager.container.getActiveWidget();
        if(widget.currentRow.VRPERDESC == '0'){
            widget.getAction('deleteListaProd').isVisible = false;
        } else {
            widget.getAction('deleteListaProd').isVisible = true;
        }
    };
    
    this.editListaPorProduto = function(){
        var widget = templateManager.container.getActiveWidget();
        General.edit(widget);
        if (widget.currentRow.VRPERDESC == '0'){
            widget.currentRow.is_new = true;
        } else {
            widget.currentRow.is_new = false;
        }
    };
    
    this.deleteListaPorProduto = function(){
        var widget = templateManager.container.getActiveWidget();
        General.deleteCrud(widget);/*.then(function(){
            // widget.reload();
        });*/
    };
    
    this.saveListaPorProduto = function(){
        var widget = templateManager.container.getActiveWidget();
        if (widget.isValid()) { 
            widget.currentRow.NRTABDESC = widget.getParent().getParent().currentRow.NRTABDESC;
            if (widget.currentRow.is_new == true){
                widget.currentRow.__is_new = true;
            } 
            if (widget.currentRow.VRPERDESC > 0) {
                General.saveCrud(widget).then(function(success){
                    ScreenService.showMessage('Salvo com sucesso.');
                }).catch(function(e){
                    ScreenService.showMessage(e.data.error);
                });
            } else if (!widget.currentRow.is_new && widget.currentRow.VRPERDESC == '0') {
                widget.removeRow().then(function () {
                    ScreenService.closeSwipe().then(function () {
                        widget.activate();
                    });
                });
            } else {
                widget.view();
            }
        }
    };
    
    /*
    this.savelistaItemDescProd = function(widget){
        
        Ped02300PrecoBaseServices.retornaOperadorLogado().then(function(operadorLogado){
            widget.currentRow.CDOPERATZIPB =  operadorLogado[0].CDOPERADOR;
            General.saveCrud(widget);
        });
        
    };
    
    this.setDataSourceFilterPromocao = function(widget){
        widget.dataSourceFilter = [
            {
                name: "P_CDPRECOBASE",
                operator: "=",
                value: widget.getParent().getParent().getParent().currentRow.CDPRECOBASE
            },
            {
                name: "P_DTINIVALIPB",
                operator: "=",
                value: widget.getParent().currentRow.DTINIVALIPB
            },
            {
                name: "P_CDPRODUTO",
                operator: "=",
                value: widget.getParent().currentRow.CDPRODUTO
            }
        ];
        widget.reload();
    };
    
    this.getNrorg = function(){
        return templateManager.container.getWidget('promocao').currentRow.NRORG;
    };
    
    this.salvarPromoPrBase = function(widget){
        if(widget.isValid()){
            this.setPreco(widget);
            var dadosPromoPrBase;
            if(widget.currentRow.__is_new){
                dadosPromoPrBase = {
                    "__createdLocal": true,
                    "__index": 4,
                    "__isSelected": false,
                    "__is_new": true,
                    "__notSelectable": false,
                    "CDPRECOBASE": widget.getParent().getParent().getParent().currentRow.CDPRECOBASE,
                    "DTINIVALIPB": widget.getParent().currentRow.DTINIVALIPB,
                    "CDPRODUTO": widget.getParent().currentRow.CDPRODUTO,
                    "IDTIPOPROMO": widget.currentRow.IDTIPOPROMO,
                    "VRPERBASEPROMO": widget.currentRow.VRPERBASEPROMO,
                    "IDDIASPROMO": widget.currentRow.IDDIASPROMO,
                    "DTINIPROMO": widget.currentRow.DTINIPROMO,
                    "DTFINPROMO": widget.currentRow.DTFINPROMO,
                    "VRTOTALPROMO": widget.currentRow.VRTOTALPROMO,
                    "IDSTATUSPROMO": widget.currentRow.IDSTATUSPROMO,
                    "NRORG": this.getNrorg()
                };
            } else {
                dadosPromoPrBase = {
                    "__index": 2,
                    "__isSelected": false,
                    "__is_new": false,
                    "__notSelectable": false,
                    "CDPRECOBASE": widget.getParent().getParent().getParent().currentRow.CDPRECOBASE,
                    "DTINIVALIPB": widget.getParent().currentRow.DTINIVALIPB,
                    "CDPRODUTO": widget.getParent().currentRow.CDPRODUTO,
                    "IDTIPOPROMO": widget.currentRow.IDTIPOPROMO,
                    "VRPERBASEPROMO": widget.currentRow.VRPERBASEPROMO,
                    "IDDIASPROMO": widget.currentRow.IDDIASPROMO,
                    "DTINIPROMO": widget.currentRow.DTINIPROMO,
                    "DTFINPROMO": widget.currentRow.DTFINPROMO,
                    "VRTOTALPROMO": widget.currentRow.VRTOTALPROMO,
                    "IDSTATUSPROMO": widget.currentRow.IDSTATUSPROMO,
                    "NRORG": this.getNrorg()
                };
            }
            Ped02300PrecoBaseServices.setPromoPrBase(dadosPromoPrBase).then(function(){
                ScreenService.closeSwipe();
                widget.getField('VRPERBASEPROMO').readOnly = true;
                widget.getField('VRTOTALPROMO').readOnly = false;
                widget.reload();
            }.bind(this), function (error) {
                ScreenService.showMessage(error.dadosPrecoBase.error);
            });
        }
    };
    
    this.editar = function(widget){
        if(widget.currentRow.VRITEPREBASE == null){
            widget.currentRow.__is_new = true;
            widget.currentRow.CDOPERATZIPB = getLocalVar("ERP_CDOPERADOR");
            widget.currentRow.DTHRATZIPB = moment().format('DD/MM/YYYY');
            widget.currentRow.CDPRECOBASE = General.getFieldValue('CDPRECOBASE', 'precoBase');
        }
        General.edit(widget);
    };
    
    this.setFieldValor = function(args){
        var row = args.owner.field.widget.currentRow;
        if(row.IDTIPOPROMO != "V"){
            args.owner.field.widget.getField('VRPERBASEPROMO').readOnly = false;
        } else {
            args.owner.field.widget.getField('VRPERBASEPROMO').readOnly = true;
        }
    };
    
    this.setPreco = function(widget){
        var porcentagem;
        var row = widget.currentRow;
        row.VRITEPREBASE = General.getFieldValue('VRITEPREBASE','listaItemDescProd');
        if(row.IDTIPOPROMO == "A"){
            porcentagem = (row.VRITEPREBASE * row.VRPERBASEPROMO) / 100;
            row.VRTOTALPROMO = row.VRITEPREBASE + porcentagem;
            widget.getField('VRTOTALPROMO').readOnly = true;
            widget.reload();
        } 
        if(row.IDTIPOPROMO == "D"){
            porcentagem = (row.VRITEPREBASE * row.VRPERBASEPROMO) / 100;
            row.VRTOTALPROMO = row.VRITEPREBASE - porcentagem;
            widget.getField('VRTOTALPROMO').readOnly = true;
            widget.reload();
        }
    };
    
    this.setView = function(widget){
        if(widget.container.getWidget('listaItemDescProd').getField('VRITEPREBASE').value() == undefined){
            General.changeWidgetAcessibility(widget.widgets,false);
        } else {
            General.changeWidgetAcessibility(widget.widgets,true);
        }
        switch (widget.getParent().getParent().currentRow.IDULTPRECPROMO) {
            case 'S':
                widget.widgets[0].isVisible = true;
                widget.widgets[1].isVisible = false;
                widget.widgets[2].isVisible = true;
                break;
            case 'N':
                widget.widgets[0].isVisible = false;
                widget.widgets[1].isVisible = true;
                widget.widgets[2].isVisible = true;
                break;
        }
        widget.reload();
    };
    
    this.prodIniFator = function(widget){
        var row = widget.currentRow;
        widget.getField('NMPRODFINFATOR').readOnly = !row.NMPRODINIFATOR;
        widget.getField('NMPRODFINFATOR').readOnlyOnEdit = !row.NMPRODINIFATOR;
        this.prodFinFator(widget);
    };
    
    this.prodFinFator = function(widget){
        var row = widget.currentRow;
        widget = widget.container.getWidget('produtosFatorAjuste');
        widget.dataSourceFilter = [
            {
                name: "P_CDFATPRECO",
                operator: "=",
                value: General.getFieldValue('CDFATPRECO', 'fator')
            }
        ];
        if(row.NMPRODFINFATOR){
            widget.dataSourceFilter.push(
                {
                    name: "P_PRODINI",
                    operator: "=",
                    value: row.P_PRODINI
                }
            );
            widget.dataSourceFilter.push(
                {
                    name: "P_PRODFIN",
                    operator: "=",
                    value: row.P_PRODFIN
                }
            );
        } else {
            widget.dataSourceFilter.push(
                {
                    name: "P_PRODINI",
                    operator: "=",
                    value: "invalido"
                }
            );
        }
        widget.reload();
    };
    
    this.editarFator = function(widget){
        if(widget.currentRow.VRFATPRECO == null){
            widget.currentRow.__is_new = true;
            widget.currentRow.CDFATPRECO = General.getFieldValue('CDFATPRECO', 'fator');
        }
        General.edit(widget);
    };
    
    this.validaValor = function(widget){
        if(widget.currentRow.VRPREBASECONV <= 0 || widget.currentRow.VRPREBASECONV == null){
            ScreenService.showMessage("O valor não pode ser menor ou igual a zero.");
        } else { 
            General.saveCrud(widget);
            widget.reload();
        }    
    };
    
    this.preparaExportacao = function(widget){
        checkedFields[0] = widget.getCheckedRows();
        
        var ItemNull = false;
        var ItemCount = 0;
        var ItemNameArray = [];
        var ItemNameString = "";
        
        if(!checkedFields[0][0]) {
            ScreenService.showMessage("É necessário selecionar um produto.");
        } else {
            for(var i = 0; i < checkedFields[0].length; i++){
                if(checkedFields[0][i].CDPRECOBASE == null){
                    ItemNull = true;
                    ItemCount++;
                    ItemNameArray.push(checkedFields[0][i].NMPRODUTO);
                }
            }
            
            if (ItemNull) {
                
                ItemNameString = "'" + ItemNameArray[0] + "'";
                
                for (i = 1; i < ItemNameArray.length; i++) {
                    
                    if(i == ItemNameArray.length-1) {
                        ItemNameString += " e '" + ItemNameArray[i] + "'";
                    } else {
                        ItemNameString += ", '" + ItemNameArray[i] + "'";
                    }
                }
                
                //ScreenService.showMessage("O(s) produto(s) " + ItemNameString + " não possui(em) preço(s).");
                
                var var_produtosSemPreco_msg = "PRODUTO_NAO_POSSUI_PRECO";
                MessageService.showMessageByCode(var_produtosSemPreco_msg,{"PRODUTO":ItemNameString});
                return 0;
                
            } else {
                var newWidget = templateManager.container.getWidget("exportItem_popup");
                newWidget.dataSourceFilter = [
                    {
                        "name": "CDPRECOBASE",
                        "operator": "<>",
                        "value": widget.getParent().getParent().currentRow.CDPRECOBASE
                    }
                ];
                newWidget.fields.forEach(function(field) {
                    field.value(null);
                });
                newWidget.reload();
                ScreenService.openPopup(newWidget);
            }
            
            
        }
    };
    
    this.closeExport = function(widget) {
      ScreenService.closePopup();
      widget.isVisible = false;
    };
    
    this.exportPrecos = function(widget){
        checkedFields[1] = widget.getCheckedRows();
        
        restEngine.post("ped_pedidos#/exportarItem",{
            'requestType': 'DataSet', 
            'dataset': [checkedFields]
            
        }).then(function(success) {
            ScreenService.showMessage("Itens importados com sucesso.");
            ScreenService.closePopup();  
        }, function(callback){
            ScreenService.showMessage("Não foi possível exporta os itens selecionados.");
            ScreenService.closePopup();  
        });
        widget.isVisible = false;
        ScreenService.closePopup();
    };
    
    this.reajuste = function(widget){
        checkedFieldsReajuste[0] = widget.getCheckedRows();
        
        var ItemReajusteNull = false;
        var ItemReajusteCount = 0;
        var ItemReajusteNameArray = [];
        var ItemReajusteNameString = "";
        
        if(!checkedFieldsReajuste[0][0]) {
            ScreenService.showMessage("É necessário selecionar um produto.");
        } else {
            for(var i = 0; i < checkedFieldsReajuste[0].length; i++){
                if(checkedFieldsReajuste[0][i].CDPRECOBASE == null){
                    ItemReajusteNull = true;
                    ItemReajusteCount++;
                    ItemReajusteNameArray.push(checkedFieldsReajuste[0][i].NMPRODUTO);
                }
            }
            
            if (ItemReajusteNull) {
                
                ItemReajusteNameString = "'" + ItemReajusteNameArray[0] + "'";
                
                for (i = 1; i < ItemReajusteNameArray.length; i++) {
                    
                    if(i == ItemReajusteNameArray.length-1) {
                        ItemReajusteNameString += " e '" + ItemReajusteNameArray[i] + "'";
                    } else {
                        ItemReajusteNameString += ", '" + ItemReajusteNameArray[i] + "'";
                    }
                }
                
                //ScreenService.showMessage("O(s) produto(s) " + ItemReajusteNameString + " não possui(em) preço(s).");
                
                var var_produtosSemPreco_msg = "PRODUTO_NAO_POSSUI_PRECO";
                MessageService.showMessageByCode(var_produtosSemPreco_msg,{"PRODUTO":ItemReajusteNameString});
                return 0;
                
            } else {
                ScreenService.showMessage("As promoções desse item vão ser apagados após o reajuste");
                var newWidget = templateManager.container.getWidget("reajuste_popup");
                newWidget.isVisible = true;
                newWidget.fields.forEach(function(field) {
                    field.value(null);
                });
                ScreenService.openPopup(newWidget);
            }
            
        }
    };
    
    this.reajustePrecos = function(widget){
        
        if(widget.currentRow.VRPERBASEPROMO <= 0){
            ScreenService.showMessage("O valor da porcentagem não pode ser menor ou igual a 0;");
            return 0;
        }
        
        checkedFieldsReajuste[1] = widget.currentRow.VRPERBASEPROMO;
        checkedFieldsReajuste[2] = widget.currentRow.DTFIMVALIPB;
        checkedFieldsReajuste[3] = widget.currentRow.IDTIPOREAJUSTE;
        
        
        
        restEngine.post("/reajusteItem",{'requestType': 'DataSet', 'dataset': [checkedFieldsReajuste]}).then(function() {
            ScreenService.showMessage("Itens reajustado com sucesso.");
            ScreenService.closePopup();
            widget.getParent().reload();
        });
        widget.isVisible = false;
        ScreenService.closePopup();
    };
    
    this.saveFatorPreco = function(widget){
        if(widget.currentRow.__is_new == true){    
            Ped02300PrecoBaseServices.saveFatorPreco(widget.currentRow).then(function(sucess){
                ScreenService.goBack();
                widget.reload();
            }, function(error){
                ScreenService.showMessage(error.data.error);
            });
        } else {
            General.saveCrud(widget);
        }
    };
    
    this.newRowDesc = function(widget){
        widget.newRow();
        widget.currentRow.CDPRECOBASE = widget.getParent().getParent().currentRow.CDPRECOBASE;
        widget.currentRow.CDPAIS = widget.getParent().currentRow.CDPAIS;
    };
    
    this.fieldOnChangePais = function(){
        var widget = templateManager.container.getWidget('desconto_maximo');
        var dadosWidget = templateManager.container.getWidget('desconto_maximo_grid');
        
        if(!widget.getField('NMPAIS').value()) {
            dadosWidget.isVisible = false;
            dadosWidget.deactivate();
            dadosWidget.actions.forEach(function(action){
                action.isVisible = false;
            });
            dadosWidget.reload();
        } else {
            dadosWidget.isVisible = true;
            dadosWidget.activate();
            dadosWidget.actions.forEach(function(action){
                action.isVisible = true;
            });
            dadosWidget.reload();
        }
    };
    
    this.verificaPorcentagem = function(field){
        var valor_porcentagem = parseFloat(field.value().toString().replace(",","."));
        if((valor_porcentagem < 0) || (valor_porcentagem > 100)){
            //ScreenService.showMessage(field.label+" deve ser entre 0 e 100.");
            
            var var_valorPorcentagem_msg = "PORCENTAGEM_MSG";
            MessageService.showMessageByCode(var_valorPorcentagem_msg,{"FIELD":field.label});
            
            field.clearValue();
        }
    };*/
    
}

Configuration(function(ContextRegister) {
    ContextRegister.register('Ped08000_tabela_desconto_Controller', Ped08000_tabela_desconto_Controller);
});